<!-- #INCLUDE FILE="inc_header.asp" -->
<!-- #INCLUDE FILE="func_sql.asp" -->
<%
Sub Main()
	If intUserLevel < 4 Then
		Redirect("default.asp")
		Exit Sub
	End If

	Response.Write(H2("Categories " & strLanguageAdmin) & vbNewLine)

	Call GetValue(2, "Mode", 8)

	Select Case UCase(qryMode)
		Case "ADD":
			Call Add()
			Exit Sub
		Case "EDIT":
			Call Edit()
			Exit Sub
		Case "DELETE":
			Call Delete()
			Exit Sub
	End Select

	Response.Write(P("Please choose a category, or <a href=""admin_categories.asp?mode=add"">add a new one</a>.") & vbNewLine)
	Response.Write("<ul>" & vbNewLine)
	objRS.Open TableSelectAll(strConfigTablePrefix & "Categories", "CategoryID", "ASC"), objConn
	Do While Not objRS.EOF
		Response.Write("<li>" & objRS.Fields("CategoryTitle") & " (<a href=""admin_categories.asp?mode=edit&categoryid=" & objRS.Fields("CategoryID") & """>edit</a> / <a href=""admin_categories.asp?mode=delete&categoryid=" & objRS.Fields("CategoryID") & """>delete</a>).</li>" & vbNewLine)

		objRS.MoveNext
	Loop
	Response.Write("</ul>" & vbNewLine)

	objRS.Close
End Sub

Sub Add()
	Call GetValue(2, "CategoryID", 2)

	If Len(qryCategoryID) > 0 Then
		Redirect("admin_categories.asp")
		Exit Sub
	End If

	Call GetValue(2, "Action", 8)

	Select Case UCase(qryAction)
		Case "SQL":
			Call GetValue(1, "CategoryTitle", 8)

			If Len(frmCategoryTitle) < 1 Then
				Response.Write(Error(1, "Please ensure that the category title is correctly filled in."))
				Exit Sub
			End If

			If CategoryCheck(frmCategoryTitle) > 0 Then
				Response.Write(Error(0, "Category title taken. Please try again."))
				Exit Sub
			End If

			objRS.Open TableInsert(strConfigTablePrefix & "Categories", "CategoryTitle", "'" & SQLText(frmCategoryTitle) & "'"), objConn

			Response.Write(Success("Category added succesfully.") & vbNewLine)
		Case Else:
			Call CategoryForm(Null, Null)
	End Select
End Sub

Sub Edit()
	Call GetValue(2, "CategoryID", 2)

	If Len(qryCategoryID) < 1 Then
		Redirect("admin_categories.asp")
		Exit Sub
	End If

	Call GetValue(2, "Action", 8)

	Select Case UCase(qryAction)
		Case "SQL":
			Call GetValue(1, "CategoryTitle", 8)

			If Len(frmCategoryTitle) < 1 Then
				Response.Write(Error(1, "Please ensure that the category title is correctly filled in."))
				Exit Sub
			End If

			If CategoryCheck(frmCategoryTitle) > 1 Then
				Response.Write(Error(0, "Category title taken. Please try again."))
				Exit Sub
			End If

			objRS.Open TableUpdate(strConfigTablePrefix & "Categories", "CategoryTitle", "'" & SQLText(frmCategoryTitle) & "'", "CategoryID", qryCategoryID), objConn

			Response.Write(Success("Category ID " & qryCategoryID & " was renamed.") & vbNewLine)
		Case Else:
			Dim strCategoryTitle

			objRS.Open TableSelectWhere(strConfigTablePrefix & "Categories", "CategoryID", qryCategoryID, "CategoryID", "ASC"), objConn
			If objRS.RecordCount < 1 Then
				Redirect("admin_categories.asp")
				Exit Sub
			End If

			strCategoryTitle = objRS.Fields("CategoryTitle")

			Call CategoryForm(qryCategoryID, strCategoryTitle)
	End Select
End Sub

Sub Delete()
	Call GetValue(2, "CategoryID", 2)

	If Len(qryCategoryID) < 1 Then
		Redirect("admin_categories.asp")
		Exit Sub
	End If

	Call GetValue(2, "Action", 8)

	Select Case UCase(qryAction)
		Case "SQL":
			Call GetValue(1, "Tool", 8)

			Select Case UCase(frmTool)
				Case "NODELETE":
					Response.Write(Success("Category ID " & qryCategoryID & " was not deleted.") & vbNewLine)
					Exit Sub
				Case "DELETE":
					objRS.Open TableDelete(strConfigTablePrefix & "Categories", "CategoryID", qryCategoryID), objConn

					objRS.Open TableSelectWhere(strConfigTablePrefix & "Forums", "CategoryID", qryCategoryID, "ForumID", "ASC"), objConn

					Dim objRSMisc
					Set objRSMisc = Server.CreateObject("ADODB.RecordSet")

					Do While Not objRS.EOF
						objRSMisc.Open TableDelete(strConfigTablePrefix & "Posts", "ForumID", objRS.Fields("ForumID")), objConn
						objRSMisc.Open TableDelete(strConfigTablePrefix & "Moderators", "ForumID", objRS.Fields("ForumID")), objConn
						objRS.MoveNext
					Loop

					Set objRSMisc = Nothing
					objRS.Close

					objRS.Open TableDelete(strConfigTablePrefix & "Forums", "CategoryID", qryCategoryID), objConn

					Response.Write(Success("Category ID " & qryCategoryID & " and all posts and forums inside it were deleted.") & vbNewLine)
			End Select
		Case Else:
			Response.Write(P("Are you absolutely sure you want to delete category ID " & qryCategoryID & "? <strong>There is no way to get it back once you do this, and all forums and posts in it will be deleted.</strong>") & vbNewLine)
			Response.Write("<form action=""admin_categories.asp?mode=delete&categoryid=" & qryCategoryID & "&action=sql"" method=""post"">" & vbNewLine)
			Response.Write(Div("<strong>Don't delete:</strong>&nbsp;" & Input("radio", "tool", 1, Null, Null, "nodelete")) & vbNewLine)
			Response.Write(Div("<strong>Delete:</strong>&nbsp;" & Input("radio", "tool", 1, Null, Null, "delete")) & vbNewLine)
			Response.Write(Div(Input("submit", "submit", Null, Null, Null, "Delete")) & vbNewLine)
			Response.Write("</form>" & vbNewLine)
	End Select
End Sub

Sub CategoryForm(pvCategoryID, pvCategoryTitle)
	Response.Write("<form action=""admin_categories.asp?mode=")
	If IsNull(pvCategoryID) Then
		Response.Write("add")
	Else
		Response.Write("edit&categoryid=" & qryCategoryID)
	End If
	Response.Write("&action=sql"" method=""post"">" & vbNewLine)
	Response.Write(Div("<strong>Category title:</strong>&nbsp;" & Input("text", "categorytitle", 20, 50, Null, FormText(pvCategoryTitle))) & vbNewLine)
	Response.Write(Div(Input("submit", "submit", Null, Null, Null, "Submit")) & vbNewLine)
	Response.Write("</form>" & vbNewLine)
End Sub

Function CategoryCheck(pvCheck)
	objRS.Open TableSelectWhere(strConfigTablePrefix & "Categories", "CategoryTitle", "'" & SQLText(pvCheck) & "'", "CategoryID", "ASC"), objConn

	CategoryCheck = objRS.RecordCount

	objRS.Close
End Function
%>
<!-- #INCLUDE FILE="inc_footer.asp" -->