<!-- #INCLUDE FILE="inc_header.asp" -->
<!-- #INCLUDE FILE="func_sql.asp" -->
<%
Sub Main()
	If intUserLevel < 4 Then
		Redirect("default.asp")
		Exit Sub
	End If

	Response.Write(H2("Forums " & strLanguageAdmin) & vbNewLine)

	Call GetValue(2, "Mode", 8)

	Select Case UCase(qryMode)
		Case "ADD":
			Call Add()
			Exit Sub
		Case "EDIT":
			Call Edit()
			Exit Sub
		Case "DELETE":
			Call Delete()
			Exit Sub
	End Select

	Response.Write(P("Please choose a forum, or <a href=""admin_forums.asp?mode=add"">add a new one</a>.") & vbNewLine)
	Response.Write("<ul>" & vbNewLine)
	objRS.Open TableSelectAll(strConfigTablePrefix & "Forums", "ForumID", "ASC"), objConn
	Do While Not objRS.EOF
		Response.Write("<li>" & objRS.Fields("ForumTitle") & " (<a href=""admin_forums.asp?mode=edit&forumid=" & objRS.Fields("ForumID") & """>edit</a> / <a href=""admin_forums.asp?mode=delete&forumid=" & objRS.Fields("ForumID") & """>delete</a>).</li>" & vbNewLine)

		objRS.MoveNext
	Loop
	Response.Write("</ul>" & vbNewLine)

	objRS.Close
End Sub

Sub Add()
	Call GetValue(2, "ForumID", 2)

	If Len(qryForumID) > 1 Then
		Redirect("admin_forums.asp")
		Exit Sub
	End If

	Call GetValue(2, "Action", 8)

	Select Case UCase(qryAction)
		Case "SQL":
			Call GetValue(1, "ForumTitle", 8)
			Call GetValue(1, "ForumText", 8)
			Call GetValue(1, "CategoryID", 2)

			If Len(frmForumTitle) < 1 Or Len(frmForumText) < 1 Then
				Response.Write(Error(1, "Please ensure that all fields are correctly filled in."))
				Exit Sub
			End If

			If ForumCheck(frmForumTitle) > 0 Then
				Response.Write(Error(0, "Forum title taken. Please try again."))
				Exit Sub
			End If

			objRS.Open TableInsert(strConfigTablePrefix & "Forums", "CategoryID, ForumTitle, ForumText", frmCategoryID & ", '" & SQLText(frmForumTitle) & "', '" & SQLMemo(frmForumText) & "'"), objConn

			Response.Write(Success("Forum added succesfully.") & vbNewLine)
		Case Else:
			Call ForumForm(Null, Null, Null)
	End Select
End Sub

Sub Edit()
	Call GetValue(2, "ForumID", 2)

	If Len(qryForumID) < 1 Then
		Redirect("admin_forums.asp")
		Exit Sub
	End If

	Call GetValue(2, "Action", 8)

	Select Case UCase(qryAction)
		Case "SQL":
			Call GetValue(1, "ForumText", 8)
			Call GetValue(1, "ForumTitle", 8)
			Call GetValue(1, "CategoryID", 2)

			If Len(frmForumTitle) < 1 Or Len(frmForumText) < 1 Then
				Response.Write(Error(1, "Please ensure that the all fields are correctly filled in."))
				Exit Sub
			End If

			If ForumCheck(frmForumTitle) > 1 Then
				Response.Write(Error(0, "Forum title taken. Please try again."))
				Exit Sub
			End If

			objRS.Open TableUpdate(strConfigTablePrefix & "Forums", "CategoryID, ForumTitle, ForumText", frmCategoryID & "> '" & SQLText(frmForumTitle) & "'> '" & SQLMemo(frmForumText) & "'", "ForumID", qryForumID), objConn

			Response.Write(Success("Forum ID " & qryForumID & " was edited.") & vbNewLine)
		Case Else:
			Dim strForumTitle, strForumText

			objRS.Open TableSelectWhere(strConfigTablePrefix & "Forums", "ForumID", qryForumID, "ForumID", "ASC"), objConn
			If objRS.RecordCount < 1 Then
				Redirect("admin_forums.asp")
				Exit Sub
			End If

			strForumTitle = objRS.Fields("ForumTitle")
			strForumText = objRS.Fields("ForumText")

			objRS.Close

			Call ForumForm(qryForumID, strForumTitle, strForumText)
	End Select
End Sub

Sub Delete()
	Call GetValue(2, "ForumID", 2)

	If Len(qryForumID) < 1 Then
		Redirect("admin_forums.asp")
		Exit Sub
	End If

	Call GetValue(2, "Action", 8)

	Select Case UCase(qryAction)
		Case "SQL":
			Call GetValue(1, "Tool", 8)

			Select Case UCase(frmTool)
				Case "NODELETE":
					Response.Write(Success("Forum ID " & qryForumID & " was not deleted.") & vbNewLine)
					Exit Sub
				Case "DELETE":
					objRS.Open TableDelete(strConfigTablePrefix & "Forums", "ForumID", qryForumID), objConn

					objRS.Open TableDelete(strConfigTablePrefix & "Posts", "ForumID", qryForumID), objConn

					objRS.Open TableDelete(strConfigTablePrefix & "Moderators", "ForumID", qryForumID), objConn

					Response.Write(Success("Forum ID " & qryForumID & " and all posts inside it were deleted.") & vbNewLine)
			End Select
		Case Else:
			Response.Write(P("Are you absolutely sure you want to delete forum ID " & qryForumID & "? <strong>There is no way to get it back once you do this, and all posts in it will be deleted.</strong>") & vbNewLine)
			Response.Write("<form action=""admin_forums.asp?mode=delete&forumid=" & qryForumID & "&action=sql"" method=""post"">" & vbNewLine)
			Response.Write(Div("<strong>Don't delete:</strong>&nbsp;" & Input("radio", "tool", 1, Null, Null, "nodelete")) & vbNewLine)
			Response.Write(Div("<strong>Delete:</strong>&nbsp;" & Input("radio", "tool", 1, Null, Null, "delete")) & vbNewLine)
			Response.Write(Div(Input("submit", "submit", Null, Null, Null, "Delete")) & vbNewLine)
			Response.Write("</form>" & vbNewLine)
	End Select
End Sub

Sub ForumForm(pvForumID, pvForumTitle, pvForumText)
	Dim intCategoryID

	If Len(pvForumID) > 0 Then
		objRS.Open TableSelectWhere(strConfigTablePrefix & "Forums", "ForumID", pvForumID, "ForumID", "ASC"), objConn

		intCategoryID = objRS.Fields("CategoryID")

		objRS.Close
	End If

	Response.Write("<form action=""admin_forums.asp?mode=")
	If IsNull(pvForumID) Then
		Response.Write("add")
	Else
		Response.Write("edit&forumid=" & qryForumID)
	End If
	Response.Write("&action=sql"" method=""post"">" & vbNewLine)
	Response.Write("<div><strong>Category:</strong>&nbsp;<select name=""categoryid"">")

	objRS.Open TableSelectAll(strConfigTablePrefix & "Categories", "CategoryID", "ASC"), objConn
	Do While Not objRS.EOF
		Response.Write("<option value=""" & objRS.Fields("CategoryID") & """")

		If intCategoryID = objRS.Fields("CategoryID") Then
			Response.Write(" selected")
		End If

		Response.Write(">" & objRS.Fields("CategoryTitle") & "</option>")

		objRS.MoveNext
	Loop

	objRS.Close
	Response.Write("</select></div>" & vbNewLine)
	Response.Write(Div("<strong>Forum title:</strong>&nbsp;" & Input("text", "forumtitle", 20, 50, Null, FormText(pvForumTitle))) & vbNewLine)
	Response.Write(Div("<strong>Forum text:</strong>&nbsp;" & Input("textarea", "forumtext", 40, Null, 3, FormMemo(pvForumText))) & vbNewLine)
	Response.Write(Div(Input("submit", "submit", Null, Null, Null, "Submit")) & vbNewLine)
	Response.Write("</form>" & vbNewLine)
End Sub

Function ForumCheck(pvCheck)
	objRS.Open TableSelectWhere(strConfigTablePrefix & "Forums", "ForumTitle", "'" & SQLText(pvCheck) & "'", "ForumID", "ASC"), objConn

	ForumCheck = objRS.RecordCount

	objRS.Close
End Function
%>
<!-- #INCLUDE FILE="inc_footer.asp" -->