<%
Function TableFields(pvTableName)
	Dim pvTableFields

	Select Case UCase(pvTableName)
		Case UCase(strConfigTablePrefix & "Categories"):
			pvTableFields = "CategoryID, CategoryTitle"
		Case UCase(strConfigTablePrefix & "Config"):
			pvTableFields = "ConfigForumTitle, ConfigForumCopyright, ConfigEmailType, ConfigEmailServer, ConfigEmailSender, ConfigDateFormat, ConfigPageSize, ConfigLanguage, ConfigForumStyle"
		Case UCase(strConfigTablePrefix & "Forums"):
			pvTableFields = "ForumID, CategoryID, ForumTitle, ForumText"
		Case UCase(strConfigTablePrefix & "Moderators"):
			pvTableFields = "ForumID, UserID"
		Case UCase(strConfigTablePrefix & "Posts"):
			pvTableFields = "PostID, ForumID, UserID, ParentID, PostPosted, PostStatus, PostTitle, PostText"
		Case UCase(strConfigTablePrefix & "Users"):
			pvTableFields = "UserID, UserPosted, UserEmail, UserPassword, UserLevel, UserLink, UserTitle, UserText"
		Case Else:
			pvTableFields = "*"
	End Select

	pvTableFields = TableFields
End Function

Function TableSelectWhere(pvTableName, pvFieldName, pvFieldValue, pvFieldOrderBy, pvSortDirection)
	Dim pvTableFields

	Select Case UCase(pvTableName)
		Case UCase(strConfigTablePrefix & "Categories"):
			pvTableFields = "CategoryID, CategoryTitle"
		Case UCase(strConfigTablePrefix & "Config"):
			pvTableFields = "ConfigForumTitle, ConfigForumCopyright, ConfigEmailType, ConfigEmailServer, ConfigEmailSender, ConfigDateFormat, ConfigPageSize, ConfigLanguage, ConfigForumStyle"
		Case UCase(strConfigTablePrefix & "Forums"):
			pvTableFields = "ForumID, CategoryID, ForumTitle, ForumText"
		Case UCase(strConfigTablePrefix & "Moderators"):
			pvTableFields = "ForumID, UserID"
		Case UCase(strConfigTablePrefix & "Posts"):
			pvTableFields = "PostID, ForumID, UserID, ParentID, PostPosted, PostStatus, PostTitle, PostText"
		Case UCase(strConfigTablePrefix & "Users"):
			pvTableFields = "UserID, UserPosted, UserEmail, UserPassword, UserLevel, UserLink, UserTitle, UserText"
		Case Else:
			pvTableFields = "*"
	End Select

	TableSelectWhere = "SELECT " & pvTableFields & " FROM " & pvTableName & " " &_
	"WHERE " & pvFieldName & " = " & pvFieldValue & " " &_
	"ORDER BY " & pvFieldOrderBy & " " & pvSortDirection & ";"
End Function

Function TableSelectAll(pvTableName, pvFieldOrderBy, pvSortDirection)
	Dim pvTableFields

	Select Case UCase(pvTableName)
		Case UCase(strConfigTablePrefix & "Categories"):
			pvTableFields = "CategoryID, CategoryTitle"
		Case UCase(strConfigTablePrefix & "Config"):
			pvTableFields = "ConfigForumTitle, ConfigForumCopyright, ConfigEmailType, ConfigEmailServer, ConfigEmailSender, ConfigDateFormat, ConfigPageSize, ConfigLanguage, ConfigForumStyle"
		Case UCase(strConfigTablePrefix & "Forums"):
			pvTableFields = "ForumID, CategoryID, ForumTitle, ForumText"
		Case UCase(strConfigTablePrefix & "Moderators"):
			pvTableFields = "ForumID, UserID"
		Case UCase(strConfigTablePrefix & "Posts"):
			pvTableFields = "PostID, ForumID, UserID, ParentID, PostPosted, PostStatus, PostTitle, PostText"
		Case UCase(strConfigTablePrefix & "Users"):
			pvTableFields = "UserID, UserPosted, UserEmail, UserPassword, UserLevel, UserLink, UserTitle, UserText"
		Case Else:
			pvTableFields = "*"
	End Select

	TableSelectAll = "SELECT " & pvTableFields & " FROM " & pvTableName & " " &_
	"ORDER BY " & pvFieldOrderBy & " " & UCase(pvSortDirection) & ";"
End Function


Sub GetValue(pvMethod, pvName, pvDataType)
	Dim pvTemp

	Select Case pvMethod
		Case 1:
			pvMethod = "Form"
			pvTemp = "frm"
		Case 2:
			pvMethod = "QueryString"
			pvTemp = "qry"
		Case 3:
			pvMethod = "Cookies"
			pvTemp = "cki"
	End Select

	pvTemp = pvTemp & pvName & " = Trim(Request." & pvMethod
	If pvMethod = "Cookies" Then
			pvTemp = pvTemp & "(strConfigForumTitle)"
	End If
	pvTemp = pvTemp & "(""" & LCase(pvName) & """))"

	Execute(pvTemp)

	Select Case UCase(pvMethod)
		Case "FORM":
			pvTemp = "frm" & pvName
		Case "QUERYSTRING":
			pvTemp = "qry" & pvName
		Case "COOKIES":
			pvTemp = "cki" & pvName
	End Select

	Call ConvertValue(pvTemp, pvDataType)
End Sub

Sub ConvertValue(pvValue, pvDataType)
	Dim pvTemp

	pvTemp = "pvTemp = Len(" & pvValue & ")"
	Execute(pvTemp)

	If pvTemp < 1 Then
		pvDataType = 1
	End If

	Select Case CInt(pvDataType)
		Case 0, 1:
			pvTemp = Null
		Case 2:
			pvTemp = "CInt(" & pvValue & ")"
		Case 3:
			pvTemp = "CLng(" & pvValue & ")"
		Case 4:
			pvTemp = "CSng(" & pvValue & ")"
		Case 5:
			pvTemp = "CDbl(" & pvValue & ")"
		Case 6:
			pvTemp = "CCur(" & pvValue & ")"
		Case 7:
			pvTemp = "CDate(" & pvValue & ")"
		Case 8:
			pvTemp = "CStr(" & pvValue & ")"
		Case 11:
			pvTemp = "CBool(" & pvValue & ")"
		Case Else:
			pvTemp = "CInt(" & pvValue & ")"
	End Select

	If CInt(pvDataType) > 1 Then
		pvTemp = pvValue & " = " & pvTemp
	Else
		pvTemp = pvValue & " = """""
	End If

	Execute(pvTemp)
End Sub

Sub GetConfig(pvConfigFields)
	Dim pvArrConfigFields, pvIntConfigFields, pvIntLooping, pvTemp

	pvArrConfigFields = Split(pvConfigFields, ", ")
	pvIntConfigFields = UBound(pvArrConfigFields)
	pvIntLooping = 0

	objRS.Open TableSelectAll(strConfigTablePrefix & "Config", "ConfigForumTitle", "DESC"), objConn, adOpenStatic

	Do While pvIntLooping <= pvIntConfigFields
		pvTemp = "str" & pvArrConfigFields(pvIntLooping) & " = objRS.Fields(""" & pvArrConfigFields(pvIntLooping) & """)"

		Execute(pvTemp)

		pvIntLooping = pvIntLooping + 1
	Loop

	objRS.Close
End Sub

Sub Login()
	Dim pvTemp, intUserID

	Call GetValue(1, "UserTitle", 8)
	Call GetValue(1, "UserPassword", 8)

	If IsNull(frmUserTitle) Or IsNull(frmUserPassword) Then
		Response.Write(Error(1, "Please check that all fields are filled in correctly."))
	End If

	objRS.Open TableSelectWhere(strConfigTablePrefix & "Users", "UserTitle", "'" & frmUserTitle & "'", "UserID", "ASC"), objConn, adOpenStatic

	If objRS.Fields("UserPassword") = frmUserPassword Then
		intUserID = objRS.Fields("UserID")

		Response.Cookies(strConfigForumTitle)("UserID") = intUserID
		Response.Cookies(strConfigForumTitle)("UserPassword") = frmUserPassword
		Response.Cookies(strConfigForumTitle).Expires = Now() + 999
		pvTemp = "strLogin = Success(""Logged in successfully."")"
	Else
		pvTemp = "strLogin = Error(1, ""User name or password incorrect."")"
	End If

	Execute(pvTemp)

	objRS.Close
End Sub

Sub Logout()
	Dim pvTemp

	Response.Cookies(strConfigForumTitle)("UserID") = ""
	Response.Cookies(strConfigForumTitle)("UserPassword") = ""
	Response.Cookies(strConfigForumTitle).Expires = Now()

	pvTemp = "strLogout = Success(""Logged out successfully."")"

	Execute(pvTemp)
End Sub

Function ShowModerators(pvForumID)
	Dim objRSMisc, objRSMiscModerators

	Set objRSMisc = Server.CreateObject("ADODB.Recordset")
	Set objRSMiscModerators = Server.CreateObject("ADODB.Recordset")

	Dim pvIntLooping, pvIntForumUserID, pvForumUserTitle

	pvIntLooping = 0

	objRSMisc.Open TableSelectWhere(strConfigTablePrefix & "Moderators", "ForumID", pvForumID, "UserID", "ASC"), objConn, adOpenStatic

	Do While Not objRSMisc.EOF
		pvIntForumUserID = objRSMisc.Fields("UserID")

		objRSMiscModerators.Open TableSelectWhere(strConfigTablePrefix & "Users", "UserID", pvIntForumUserID, "UserTitle", "ASC"), objConn, adOpenStatic

		pvForumUserTitle = objRSMiscModerators.Fields("UserTitle")

		objRSMiscModerators.Close

		ShowModerators = ShowModerators & "<a href=""user.asp?userid=" & pvIntForumUserID & """>" & pvForumUserTitle & "</a>"

		pvIntLooping = pvIntLooping + 1

		If pvIntLooping < objRSMisc.RecordCount Then
			ShowModerators = ShowModerators & ", "
		End If

		objRSMisc.MoveNext
	Loop

	If	ShowModerators = "" Then
		ShowModerators = "No moderators."
	End If

	objRSMisc.Close

	Set objRSMisc = Nothing
	Set objRSMiscModerators = Nothing
End Function

Function ShowLastPost(pvID, pvType)
	Dim objRSMisc

	Set objRSMisc = Server.CreateObject("ADODB.Recordset")

	Select Case UCase(pvType)
		Case "FORUM":
			objRSMisc.Open TableSelectWhere(strConfigTablePrefix & "Posts", "ForumID", pvID, "PostPosted", "DESC"), objConn, adOpenStatic
		Case "TOPIC":
			objRSMisc.Open TableSelectWhere(strConfigTablePrefix & "Posts", "ParentID", pvID, "PostPosted", "DESC"), objConn, adOpenStatic
	End Select

	If objRSMisc.EOF Then
		ShowLastPost = "Never"
	Else
		ShowLastPost = ConvertDate(objRSMisc.Fields("PostPosted"))
	End If

	objRSMisc.Close

	Set objRSMisc = Nothing
End Function

Function ShowFolder(pvDteLastPost, pvIntStatus)
	Dim pvTemp

	If Len(pvDteLastPost) < 1 Then
		ShowFolder = "<img src=""img_folder_old" & pvTemp & ".gif"" height=""15"" width=""15"" alt=""Old""/>"
	End If

	If pvIntStatus < 1 Then
		pvTemp = "_closed"
	End If

	Call GetValue(3, "UserLastVisited", 7)

	If pvDteLastPost > ckiUserLastVisited Then
		ShowFolder = "<img src=""img_folder_new" & pvTemp & ".gif"" height=""15"" width=""15"" alt=""New""/>"
	Else
		ShowFolder = "<img src=""img_folder_old" & pvTemp & ".gif"" height=""15"" width=""15"" alt=""Old""/>"
	End If
End Function

Function ShowPosts(pvID, pvType)
	Dim objRSMisc

	Set objRSMisc = Server.CreateObject("ADODB.Recordset")

	Select Case UCase(pvType)
		Case "FORUM":
			objRSMisc.Open TableSelectWhere(strConfigTablePrefix & "Posts", "ForumID", pvID, "PostID", "ASC"), objConn, adOpenStatic
		Case "TOPIC":
			objRSMisc.Open TableSelectWhere(strConfigTablePrefix & "Posts", "ParentID", pvID, "PostPosted", "DESC"), objConn, adOpenStatic
	End Select

	ShowPosts = objRSMisc.RecordCount

	objRSMisc.Close

	Set objRSMisc = Nothing
End Function

Function ShowUser(pvUserID)
	Dim objRSMisc, strTemp

	Set objRSMisc = Server.CreateObject("ADODB.Recordset")

	objRSMisc.Open TableSelectWhere(strConfigTablePrefix & "Users", "UserID", pvUserID, "UserID", "ASC"), objConn, adOpenStatic

	strTemp = objRSMisc.Fields("UserTitle")

	ShowUser = "<a href=""user.asp?userid=" & pvUserID & """>" & strTemp & "</a>"

	objRSMisc.Close

	Set objRSMisc = Nothing
End Function

Function ConvertDate(pvDte)
	ConvertDate = FormatDateTime(pvDte, strConfigDateFormat)
End Function

Sub Redirect(pvURL)
	Response.Write("<meta http-equiv=""refresh"" content=""1; url=" & pvURL & """/>")
End Sub
%>